; Programa: Ejemplo de agente bsico humano para jugar a los bloques
;           ver apuntes Tema 3 (ej. bsqueda en escalada: 
;           http://soma.etsii.ull.es/iia/transp/rp/img27.gif)
;
; Asignatura: Introduccin a la Inteligencia Artificial
;             ETSII - ULL
; Prctica: 6a (sistemas de produccin)
; Profesor: Patricio Garca Bez
; Fecha: 20/5/2004
; Comentarios:
;              Hace uso del package bloques
;              (load "bloques")
;


(use-package "bloques")


(defvar *version-agente-humano* "0.1" "Versin de agente-humano.lsp")

(defun rangos-mov-col (ini fin excepto)
  "Calcula lista de movimientos posibles (ini a fin - excepto)"
  (cond
   ((> ini fin) nil)
   ((= ini excepto) (rangos-mov-col (1+ ini) fin excepto))
   (t (cons ini (rangos-mov-col (1+ ini) fin excepto)))))


; Agente humano
;--------------

(defun agente-humano ()
  "Agente humano para mover bloques"
  (let ((cols (first (gen-bloq)))
	org
	des)
    (do ((solucion nil (cons (list org des) solucion)))
        ; Salir cuando encontremos solucin, devolvindola
	((sol-val-bloq cols) (vis-bloq cols) (reverse solucion))
      (vis-bloq cols)
      ; Iterar hasta entrar un movimiento legal
      (loop 
	(format t "~%Columna origen ~s? " 
		(rangos-mov-col 1 (length cols) 0))
	(setf org (read))
	(format t "Columna destino ~s? " 
		(rangos-mov-col 0 (length cols) org))
	(setf des (read))
	(if (or (not (numberp org))
		(not (numberp des))
		(not (mov-val-bloq org des cols)))
	    (progn
	      (vis-bloq cols)
	      (format t "~%~s,~s: movimiento no vlido" org des))
	  (progn
	    (setf cols (mov-bloq org des cols))
	    (return)))))))


; Para pruebas:
; -------------
;
#|
(load "bloques")
(load "agente-humano")

(help 'inic-bloq)
(help 'gen-bloq)
(help 'sol-val-bloq)
(help 'vis-bloq)
(help 'mov-val-bloq)
(help 'mov-bloq)

(inic-bloq #'agente-humano :verb t)
(inic-bloq #'agente-humano :ini '((A C B)) :obj '((C B A)) :verb t)
(inic-bloq #'agente-humano :fich "simple.blq" :verb t)
|#

